SystemOrganization addCategory: #'Glamour-Morphic-Brick'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Announcements'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Layouts'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Renderer'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-UI'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Widgets'!

LayoutPolicy subclass: #GLMBrickLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickLayout commentStamp: 'AliakseiSyrel 10/17/2014 10:12' prior: 0!
A GLMBrickLayout is low level layout class providing api for positioning bricks with specific order
!

GLMBrickLayout subclass: #GLMBrickHorizontalLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickHorizontalLinearLayout commentStamp: 'AliakseiSyrel 10/17/2014 10:37' prior: 0!
A GLMBrickHorizontalLinearLayout is Linear layout, where all Bricks are being positioned horizintally in one line. The size of Bricks depends only from each Brick's extent. If any Bricks goes outside of the parent with this layout, outside part will not be drawn.
!

GLMBrickHorizontalLinearLayout subclass: #GLMBrickHorizontalFillLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickHorizontalFillLinearLayout commentStamp: 'AliakseiSyrel 11/20/2014 13:59' prior: 0!
A GLMBrickHorizontalFillLinearLayout is Linear layout, where all Bricks are being positioned horizontally in one line. The size of Bricks depends only from each Brick's extent. If any Bricks goes outside of the parent with this layout, outside part will not be drawn. The height of all elements in this layout is the same!

!GLMBrickHorizontalFillLinearLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/20/2014 13:58'!
extentOf: aBrick in: owner

	^ (aBrick width) @ (owner height - aBrick layoutProperties marginTop - aBrick layoutProperties marginBottom)! !

!GLMBrickHorizontalLinearLayout methodsFor: 'accessing' stamp: 'AndreiChis 11/12/2014 10:32'!
layout: aBrick in: newBounds
	
	aBrick subbricks
		inject: 0
		into: [ :currentWidth :each |
			|left top newWidth|
			top := each layoutProperties marginTop.
			
			newWidth := currentWidth + each layoutProperties marginLeft.
			left := newWidth.
			
			each isBrick
				ifTrue: [ each brickBounds: ((left@top) extent: (self extentOf: each in: aBrick)) ]
				ifFalse: [ each bounds: (((left@top) extent: (self extentOf: each in: aBrick)) translateBy: aBrick globalBounds origin) ].
				
			newWidth + each width + each layoutProperties marginRight ]

	! !

GLMBrickHorizontalLinearLayout subclass: #GLMBrickHorizontalProportionalLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickHorizontalProportionalLinearLayout commentStamp: 'AliakseiSyrel 10/17/2014 10:37' prior: 0!
A GLMBrickHorizontalProportionalLinearLayout is an improvement of standard LinearLayout such that element are positioned proportionaly in the parent based on Brick>>layoutProperties horizontalPercent.
!

GLMBrickHorizontalProportionalLinearLayout subclass: #GLMBrickHorizontalFillProportionalLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickHorizontalFillProportionalLinearLayout commentStamp: 'AliakseiSyrel 10/17/2014 10:37' prior: 0!
A GLMBrickHorizontalFillProportionalLinearLayout is a slight modification of ProportionalLayout but all elements have the same height and it is the same as parent's!

!GLMBrickHorizontalFillProportionalLinearLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/17/2014 10:36'!
extentOf: aBrick in: owner
	
	^ ((owner width * aBrick layoutProperties horizontalPercent / 100) ceiling - aBrick layoutProperties marginLeft - aBrick layoutProperties marginRight) @ (owner height - aBrick layoutProperties marginTop - aBrick layoutProperties marginBottom)! !

!GLMBrickHorizontalProportionalLinearLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/17/2014 10:36'!
extentOf: aBrick in: owner
	
	^ ((owner width * aBrick layoutProperties horizontalPercent / 100) ceiling - aBrick layoutProperties marginLeft - aBrick layoutProperties marginRight) @ (aBrick height)! !

!GLMBrickHorizontalProportionalLinearLayout methodsFor: 'accessing' stamp: 'AndreiChis 11/12/2014 10:32'!
layout: aBrick in: newBounds
	
	|allowedWidth maxPercent|
	allowedWidth := aBrick width.
	maxPercent := 100.
	
	aBrick subbricks do: [ :each |
		(self percentageWidthOf: each in: aBrick) < (each layoutProperties minWidth) ifTrue: [ 
			allowedWidth := allowedWidth - each layoutProperties minWidth.
			maxPercent := maxPercent - each layoutProperties horizontalPercent.
		]
	].
	
	aBrick subbricks
		inject: 0
		into: [ :currentWidth :each |
			|left top extent maxWidth newWidth|
			top := each layoutProperties marginTop.
			
			newWidth := currentWidth + each layoutProperties marginLeft.
			left := newWidth.
						
			maxWidth := (each layoutProperties maxWidthBlock value: each) >= 0
						ifTrue: [ each layoutProperties maxWidthBlock value: each ]
						ifFalse: [ SmallInteger maxVal ].
			
			(self percentageWidthOf: each in: aBrick) < (each layoutProperties minWidth) ifTrue: [ 
				extent := (each layoutProperties minWidth - each layoutProperties marginLeft - each layoutProperties marginRight) @ ((self extentOf: each in: aBrick) y).
			]
			ifFalse: [ 	
				extent := ((((allowedWidth * each layoutProperties horizontalPercent / maxPercent) ceiling) - each layoutProperties marginLeft - each layoutProperties marginRight) min: maxWidth) @ ((self extentOf: each in: aBrick) y).
			].
			
			each isBrick
				ifTrue: [ each brickBounds: ((left@top) extent: extent) ]
				ifFalse: [ each bounds: (((left@top) extent: extent) translateBy: aBrick globalBounds origin) ].
			
			newWidth + each width + each layoutProperties marginRight.
		]
! !

!GLMBrickHorizontalProportionalLinearLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/17/2014 10:36'!
percentageWidthOf: aBrick in: owner

	^ (owner width * aBrick layoutProperties horizontalPercent / 100) ceiling! !

!GLMBrickLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/17/2014 10:35'!
extentOf: aBrick in: owner
	^ aBrick extent! !

!GLMBrickLayout methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:35'!
layout: aBrick in: newBounds
	self subclassResponsibility! !

!GLMBrickLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/19/2014 19:56'!
layoutFloating: aBrick in: newBounds
	|float left top right bottom|
	float := aBrick layoutProperties floating.
	float = #none ifTrue: [ ^ self ].
	
	float = #right ifTrue: [
		left := aBrick owner width - aBrick width - aBrick layoutProperties marginRight.
		top := aBrick layoutProperties marginTop.
		right := aBrick owner width - aBrick layoutProperties marginRight.
		bottom := aBrick owner height - aBrick layoutProperties marginBottom.
		
		aBrick isBrick
				ifTrue: [ aBrick brickBounds: ((left@top) corner: right@bottom) ]
				ifFalse: [ aBrick bounds: (((left@top) corner: right@bottom) translateBy: aBrick globalBounds origin) ] ].! !

GLMBrickLayout subclass: #GLMBrickNoLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickNoLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/19/2014 20:17'!
layout: aBrick in: newBounds
	! !

GLMBrickLayout subclass: #GLMBrickVerticalLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickVerticalLinearLayout commentStamp: 'AliakseiSyrel 10/17/2014 21:56' prior: 0!
A GLMBrickVerticalLinearLayout is Linear layout, where all Bricks are being positioned vertically in one line. The size of Bricks depends only from each Brick's extent. If any Bricks goes outside of the parent with this layout, outside part will not be drawn.
!

GLMBrickVerticalLinearLayout subclass: #GLMBrickVerticalFillLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickVerticalFillLinearLayout commentStamp: 'AliakseiSyrel 10/17/2014 21:56' prior: 0!
A GLMBrickVerticalFillLinearLayout is Linear layout, where all Bricks are being positioned vertically in one line. The size of Bricks depends only from each Brick's extent. If any Bricks goes outside of the parent with this layout, outside part will not be drawn. The width of all elements in this layout is the same
!

!GLMBrickVerticalFillLinearLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/17/2014 22:13'!
extentOf: aBrick in: owner

	^ (owner width - aBrick layoutProperties marginLeft - aBrick layoutProperties marginRight) @ (aBrick height)! !

!GLMBrickVerticalLinearLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/19/2014 19:58'!
layout: aBrick in: newBounds
	
	aBrick subbricks
		inject: 0
		into: [ :currentTopOffset :each |
			|left top maxHeight extent newTopOffset|
			each layoutProperties floating = #none ifTrue: [
				newTopOffset := currentTopOffset + each layoutProperties marginTop.
			
				left := each layoutProperties marginLeft.
				top := newTopOffset.
			
				maxHeight := (each layoutProperties maxHeightBlock value: each) >= 0
						ifTrue: [ each layoutProperties maxHeightBlock value: each ]
						ifFalse: [ SmallInteger maxVal ].
			
				extent := self extentOf: each in: aBrick.
				extent := extent x @ (extent y min: maxHeight).
			
				each isBrick
					ifTrue: [ each brickBounds: ((left@top) extent: extent) ]
					ifFalse: [ each bounds: (((left@top) extent: extent) translateBy: aBrick globalBounds origin) ].
				
				newTopOffset + each height + each layoutProperties marginBottom ]
			ifFalse: [ self layoutFloating: each in: newBounds ]
		]

	! !

GLMBrickVerticalLinearLayout subclass: #GLMBrickVerticalProportionalLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickVerticalProportionalLinearLayout commentStamp: 'AliakseiSyrel 10/18/2014 12:57' prior: 0!
A GLMBrickVerticalProportionalLinearLayout is an improvement of standard VerticalLinearLayout such that element are positioned proportionaly in the parent based on Brick>>layoutProperties verticalPercent.
!

GLMBrickVerticalProportionalLinearLayout subclass: #GLMBrickVerticalFillProportionalLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickVerticalFillProportionalLinearLayout commentStamp: 'AliakseiSyrel 10/18/2014 12:57' prior: 0!
A GLMBrickVerticalFillProportionalLinearLayout is a slight modification of VerticalProportionalLayout but all elements have the same width and it is the same as parent's!

!GLMBrickVerticalFillProportionalLinearLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 12:56'!
extentOf: aBrick in: owner
	
	^ (owner width - aBrick layoutProperties marginLeft - aBrick layoutProperties marginRight) @ ((owner height * aBrick layoutProperties verticalPercent / 100) ceiling - aBrick layoutProperties marginTop - aBrick layoutProperties marginBottom)! !

!GLMBrickVerticalProportionalLinearLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 12:55'!
extentOf: aBrick in: owner
	
	^ (aBrick width) @ ((owner height * aBrick layoutProperties verticalPercent / 100) ceiling - aBrick layoutProperties marginTop - aBrick layoutProperties marginBottom)! !

!GLMBrickVerticalProportionalLinearLayout methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 19:50'!
layout: aBrick in: newBounds
	
	|allowedHeight maxPercent|
	allowedHeight := aBrick height.
	maxPercent := 100.
	
	aBrick subbricks do: [ :each |
		each layoutProperties floating = #none ifTrue: [
			(self percentageHeightOf: each in: aBrick) < (each layoutProperties minHeight) ifTrue: [ 
				allowedHeight := allowedHeight - each layoutProperties minHeight.
				maxPercent := maxPercent - each layoutProperties verticalPercent.
			] ]
	].
	
	aBrick subbricks
		inject: 0
		into: [ :currentHeight :each |
			|left top extent maxHeight newHeight|
			each layoutProperties floating = #none ifTrue: [
				left := each layoutProperties marginLeft.
			
				newHeight := currentHeight + each layoutProperties marginTop.
				top := newHeight.
						
				maxHeight := (each layoutProperties maxHeightBlock value: each) >= 0
							ifTrue: [ each layoutProperties maxHeightBlock value: each ]
							ifFalse: [ SmallInteger maxVal ].
			
				(self percentageHeightOf: each in: aBrick) < (each layoutProperties minHeight) ifTrue: [ 
					extent := ((self extentOf: each in: aBrick) x) @ (each layoutProperties minHeight - each layoutProperties marginTop - each layoutProperties marginBottom).
				]
				ifFalse: [ 	
					extent := ((self extentOf: each in: aBrick) x) @ ((((allowedHeight * each layoutProperties verticalPercent / maxPercent) ceiling) - each layoutProperties marginTop - each layoutProperties marginBottom) min: maxHeight).
				].
			
				each isBrick
					ifTrue: [ each brickBounds: ((left@top) extent: extent) ]
					ifFalse: [ each bounds: (((left@top) extent: extent) translateBy: aBrick globalBounds origin) ].
			
				newHeight + each height + each layoutProperties marginBottom ]
			ifFalse: [ self layoutFloating: each in: newBounds ]
		]
! !

!GLMBrickVerticalProportionalLinearLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 12:47'!
percentageHeightOf: aBrick in: owner

	^ (owner height * aBrick layoutProperties verticalPercent / 100) ceiling! !

TableLayoutProperties subclass: #GLMBrickLayoutProperties
	instanceVariableNames: 'marginTop marginRight marginBottom marginLeft paddingTop paddingRight paddingBottom paddingLeft horizontalPercent verticalPercent minWidth minHeight maxWidthBlock maxHeightBlock floating'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickLayoutProperties commentStamp: 'AliakseiSyrel 10/17/2014 10:13' prior: 0!
A GLMBrickLayoutProperties is  a holder class of layout properties used by layout policy

Instance Variables
	horizontalPercent:		<Object>
	marginBottom:		<Object>
	marginLeft:		<Object>
	marginRight:		<Object>
	marginTop:		<Object>
	maxHeightBlock:		<Object>
	maxWidthBlock:		<Object>
	minHeight:		<Object>
	minWidth:		<Object>
	paddingBottom:		<Object>
	paddingLeft:		<Object>
	paddingRight:		<Object>
	paddingTop:		<Object>
	verticalPercent:		<Object>

horizontalPercent
	- xxxxx

marginBottom
	- xxxxx

marginLeft
	- xxxxx

marginRight
	- xxxxx

marginTop
	- xxxxx

maxHeightBlock
	- xxxxx

maxWidthBlock
	- xxxxx

minHeight
	- xxxxx

minWidth
	- xxxxx

paddingBottom
	- xxxxx

paddingLeft
	- xxxxx

paddingRight
	- xxxxx

paddingTop
	- xxxxx

verticalPercent
	- xxxxx
!

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 19:47'!
floating
	^ floating! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 19:47'!
floating: aSymbol
	floating := aSymbol! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 19:18'!
horizontalMargin

	^ self marginLeft + self marginRight! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 20:09'!
horizontalPercent
	^ horizontalPercent! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 20:09'!
horizontalPercent: anObject
	horizontalPercent := anObject! !

!GLMBrickLayoutProperties methodsFor: 'initialization' stamp: 'AliakseiSyrel 11/19/2014 19:47'!
initialize
	super initialize.
	
	marginBottom := 0.
	marginLeft := 0.
	marginRight := 0.
	marginTop := 0.
	paddingBottom := 0.
	paddingLeft := 0.
	paddingRight := 0.
	paddingTop := 0.
	horizontalPercent := 10.
	verticalPercent := 10.
	minWidth := 0.
	minHeight := 0.
	maxWidthBlock := [ :aTrick | -1 ]. "negative value means undefined"
	maxHeightBlock := [ :aTrick | -1 ]. "negative value means undefined"
	floating := #none! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:26'!
marginBottom
	^ marginBottom! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:26'!
marginBottom: anObject
	marginBottom := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:26'!
marginLeft
	^ marginLeft! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:27'!
marginLeft: anObject
	marginLeft := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:27'!
marginRight
	^ marginRight! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:27'!
marginRight: anObject
	marginRight := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:27'!
marginTop
	^ marginTop! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:27'!
marginTop: anObject
	marginTop := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 14:50'!
maxHeightBlock
	^ maxHeightBlock! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 14:50'!
maxHeightBlock: anObject
	maxHeightBlock := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 14:50'!
maxWidthBlock
	^ maxWidthBlock! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 14:50'!
maxWidthBlock: anObject
	maxWidthBlock := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 15:41'!
minHeight
	^ minHeight! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 15:41'!
minHeight: anObject
	minHeight := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 15:41'!
minWidth
	^ minWidth! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 15:41'!
minWidth: anObject
	minWidth := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingBottom
	^ paddingBottom! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingBottom: anObject
	paddingBottom := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingLeft
	^ paddingLeft! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingLeft: anObject
	paddingLeft := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingRight
	^ paddingRight! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingRight: anObject
	paddingRight := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingTop
	^ paddingTop! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingTop: anObject
	paddingTop := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 19:18'!
verticalMargin

	^ self marginTop + self marginBottom! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 20:09'!
verticalPercent
	^ verticalPercent! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 20:09'!
verticalPercent: anObject
	verticalPercent := anObject! !

Morph subclass: #GLMBrick
	instanceVariableNames: 'renderer data brickBounds brickOwner brickRoot subbricks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:09' prior: 0!
A GLMBrick is the main Brick class. Can hold another Bricks and contains logic of rendering, positioning bricks and also possibilities to interate with them using mouse or keyboard.

The idea of this project is to boost  performance of complicated glamour widgets where smooth and fast work is neccessary.

Instance Variables
	data:		<Object>
	renderer:		<Object>
	subbricks:		<Object>
	brickBounds:		<Object>
	brickOwner:		<Object>
	brickRoot:		<Object>

data
	- xxxxx

renderer
	- xxxxx

subbricks
	- xxxxx

brickBounds
	- xxxxx

brickOwner
	- xxxxx

brickRoot
	- xxxxx
!

GLMBrick subclass: #GLMBandBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMBandBrick commentStamp: 'AliakseiSyrel 10/18/2014 00:57' prior: 0!
A GLMBandBrick is a simple Brick with height and bounds to fit all subbricks.
Usually used within scroll panes
!

!GLMBandBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 11/21/2014 00:15'!
height
	|height|
	self heightBlock ifNotNil: [ ^ self heightBlock value: self ].
		
	height := 0.
	self subbricks do: [ :each | height := height + each layoutProperties marginTop + each layoutProperties marginBottom + each height ].
	^ height! !

!GLMBandBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/17/2014 23:02'!
initialize
	super initialize.
	
	self layoutPolicy: GLMBrickVerticalFillLinearLayout new.! !

!GLMBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/17/2014 15:52'!
morphInsideBrickExample
	|foundation brick morph|
	
	foundation := GLMFoundationBrick new.
	foundation extent: 800@400.

	brick := GLMLabelBrick new.
	brick text: 'Hello, I''m a Brick inside another Brick!!'.
	brick layoutProperties horizontalPercent: 50.
	brick color: Color lightBlue lighter.

	morph := Morph new.
	morph color: Color lightGreen lighter.
	morph layoutProperties: GLMBrickLayoutProperties new.
	morph layoutProperties horizontalPercent: 50.

	morph addMorphBack: (LabelMorph new
		contents: 'Hello, I''m a Morph inside another Morph inside Brick!!';
		hResizing: #spaceFill;
		vResizing: #spaceFill).

	foundation
		addBrickBack: brick;
		addBrickBack: morph;
		doLayout;
		openInWindow.! !

!GLMBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/4/2014 13:29'!
resizeImage: anImage scale: aScale

	((aScale > (1@0)) | (aScale > (0@1))) ifTrue: [
		^ GLMForm increaseFormExtentCentered: anImage to: (anImage extent * aScale).
	].

	aScale = (1@1) ifTrue: [
		^ anImage
	].
	
	^ anImage magnify: anImage boundingBox by: aScale smoothing: 2.! !

!GLMBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 09:48'!
addAllBricks: aCollection

	aCollection do: [ :each | self addBrickBack: each ]! !

!GLMBrick methodsFor: 'adding' stamp: 'AliaskeiSyrel 11/8/2014 17:18'!
addBrick: aBrick before: anotherBrick

	subbricks add: aBrick before: anotherBrick.
	self initializeBrick: aBrick.
	super addMorph: aBrick inFrontOf: anotherBrick.
	^ aBrick! !

!GLMBrick methodsFor: 'adding' stamp: 'AliaskeiSyrel 11/8/2014 17:18'!
addBrickBack: aBrick

	subbricks add: aBrick.
	self initializeBrick: aBrick.
	super addMorphBack: aBrick.
	^ aBrick! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/11/2014 00:41'!
bounds

	^ self globalBounds! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/17/2014 10:39'!
bounds: newBounds

	self brickBounds: (
		self brickOwner
			ifNotNil: [ newBounds translateBy: (self brickOwner globalBounds origin negated) ]
			ifNil: [ newBounds ] )! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
brickBounds
	^ brickBounds! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/18/2014 14:14'!
brickBounds: aRectangle
	"if you want to change brick's position or bounds use only this method!!"
	
	brickBounds := (aRectangle origin + ((self layoutProperties paddingLeft) @ (self layoutProperties paddingTop)))
		corner: (aRectangle corner - ((self layoutProperties paddingRight) @ (self layoutProperties paddingBottom))).
	
	bounds := self bounds.
	fullBounds := bounds! !

!GLMBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
brickGlobalOuterBounds

	^ self brickOwner
		ifNotNil: [ self brickOuterBounds translateBy: brickOwner globalBounds origin ]
		ifNil: [ super bounds ]
! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
brickOuterBounds
	^ (self brickBounds origin - ((self layoutProperties paddingLeft) @ (self layoutProperties paddingTop)))
		corner: (self brickBounds corner + ((self layoutProperties paddingRight) @ (self layoutProperties paddingBottom))).

! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
brickOwner
	^ brickOwner! !

!GLMBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/17/2014 10:44'!
brickOwner: aBrick
	"never ever use this method"
	
	brickOwner := aBrick! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
brickRoot

	^ brickRoot! !

!GLMBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/22/2014 23:34'!
brickRoot: aGLMFoundationBrick
	"never ever use this method"
	
	brickRoot := aGLMFoundationBrick.
	
	self subbricks do: [ :each | each isBrick ifTrue: [ each brickRoot: brickRoot ] ]! !

!GLMBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/18/2014 14:01'!
changed
	"Report that the area occupied by this morph should be redrawn.
	Fixed to include submorphs outside the outerBounds."
	
	"fixed direct reference to fullBounds, causing wrong results, because fullBounds are not being updated when parent's or child's bounds changed"
	^ self fullBounds 
		ifNil: [self invalidRect: self privateFullBounds]
		ifNotNil: [self invalidRect: self fullBounds]! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/18/2014 13:52'!
clippingBounds

	^ self fullBounds! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/18/2014 14:15'!
computeBounds
	"nothing to compute, everything is already computed"! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/18/2014 14:15'!
computeFullBounds
	"nothing to compute, everything is already computed"! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 16:22'!
data

	^ data! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:11'!
data: anObject
	data := anObject.
	
	self announcer announce: GLMBrickDataChanged new.! !

!GLMBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 10/18/2014 14:13'!
doLayout
	"most of the time you don't want to call this method manually"
	"nice example to check is GLMLabelBrick>>doLayout"
	
	self layoutPolicy layout: self in: self bounds.
	
	subbricks do: [ :each | each isBrick ifTrue: [ each doLayout ] ]
	! !

!GLMBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/24/2014 16:00'!
drawOn: aCanvas
	super drawOn: aCanvas.
	
	"translating canvas coordinates"
	 (aCanvas isKindOf: ClippingCanvas) ifTrue: [ ^self "no need to draw anything" ].
	self onDraw: ( aCanvas copy setOrigin: (aCanvas origin + self globalBounds origin - self brickBounds origin) clipRect: (aCanvas clipRect translateBy: aCanvas origin))! !

!GLMBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/25/2014 10:21'!
drawSubmorphsOn: aCanvas
	|  area |
	
	submorphs isEmpty ifTrue: [ ^ self ].

	area := aCanvas clipRect.
	"do smart drawing logic here"
	area width = 0 | (area height = 0) ifTrue: [ 
			"draw nothing"
			^ self ].
	
	subbricks
		do: [ :each | 
			| intersection canvas globalBounds |
			globalBounds := each isBrick
				ifTrue: [ each globalBounds ]
				ifFalse: [ each fullBounds ].
			
			intersection := area intersect: globalBounds ifNone: (0 @ 0 extent: 0 @ 0).
			canvas := aCanvas copyClipRect: intersection.
			each fullDrawOn: canvas ]! !

!GLMBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
extent

	^ self brickBounds extent! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/18/2014 16:52'!
extent: aPoint
	"to change brick's size use only this method!!"
	
	self brickBounds: (self brickBounds origin extent: aPoint)! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/18/2014 01:08'!
fullBounds

	^ self globalBounds! !

!GLMBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/18/2014 00:22'!
fullDrawOn: aCanvas
	"fixes bug in canvas, when it tries to draw a morph even if clip rect has size 0"
	aCanvas clipRect width = 0 | (aCanvas clipRect height = 0) ifTrue: [ ^ self ].
	super fullDrawOn: aCanvas.! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/18/2014 14:17'!
globalBounds
	"converts brickBounds to morhic bounds on fly"
	"if you want to implement something sophisticated that combines bricks and morphic this is right method to use"
	^ self brickOwner ifNotNil: [ self brickBounds translateBy: brickOwner globalBounds origin ] ifNil: [ 0@0 extent: 20@20 ].! !

!GLMBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/17/2014 09:55'!
globalBoundsOfArea: aRectangle

	^ aRectangle translateBy: brickOwner globalBounds origin
	! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/23/2014 18:51'!
height

	^ self heightBlock
		ifNotNil: [ self heightBlock value: self ]
		ifNil: [ self privateHeight ]! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 18:44'!
heightBlock

	^ self valueOfProperty: #brickHeightBlock ifAbsentPut: [ nil ]! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 18:43'!
heightBlock: aBlock
	"you can use a block to 'fake' a height or replace it's calculation logic without extending a brick"
	self setProperty: #brickHeightBlock toValue: aBlock! !

!GLMBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/17/2014 10:45'!
initialize
	super initialize.
	
	subbricks := OrderedCollection new.
	
	self layoutProperties: GLMBrickLayoutProperties new.
	self layoutPolicy: GLMBrickHorizontalFillProportionalLinearLayout new.
	self renderer: GLMBrickRenderer.
	self brickRoot: self.
	
	brickBounds := 0@0 extent: 50@50.
	
	self beTransparent! !

!GLMBrick methodsFor: 'initialization' stamp: 'AliaskeiSyrel 11/8/2014 17:19'!
initializeBrick: aBrick
	
	aBrick isBrick ifTrue: [
		aBrick brickRoot: self brickRoot.
		aBrick brickOwner: self ]! !

!GLMBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 10/17/2014 15:26'!
isBrick
	^ true! !

!GLMBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
isFitsInParent

	^ self brickOwner
		"if our owner is a trick"
		ifNotNil: [ self brickOwner globalBounds containsRect: self globalBounds ]
		"if our owner is a morph"
		ifNil: [ self owner ifNotNil: [ self owner bounds containsRect: self globalBounds ] ifNil: [ ^ true ] ]! !

!GLMBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/11/2014 01:38'!
onDraw: aCanvas

	self renderer render: self on: aCanvas. ! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/18/2014 13:55'!
outerBounds
	^ self fullBounds! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/18/2014 14:02'!
privateFullBounds
	^ self fullBounds! !

!GLMBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/23/2014 18:50'!
privateHeight

	^ self brickBounds height + self layoutProperties paddingTop  + self layoutProperties paddingTop! !

!GLMBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/23/2014 18:51'!
privateWidth

	^ self brickBounds width + self layoutProperties paddingLeft  + self layoutProperties paddingRight! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
relativeBounds

	^ self brickBounds translateBy: brickOwner relativeBounds origin! !

!GLMBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 15:48'!
removeAllBricks

	subbricks do: [ :each |
		each isBrick ifTrue: [
			each brickRoot: nil.
			each brickOwner: nil ] ].
	
	subbricks removeAll.
	self removeAllMorphs! !

!GLMBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 15:48'!
removeBrick: aBrick
	
	aBrick isBrick ifTrue: [
		aBrick brickRoot: nil.
		aBrick brickOwner: nil.
	].
	
	self removeMorph: aBrick.
	subbricks remove: aBrick ifAbsent: [ ^ aBrick ].
	^ aBrick! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:59'!
renderer

	^ renderer! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:59'!
renderer: aRenderer

	renderer := aRenderer! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 09:58'!
subbricks

	^ subbricks! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/23/2014 18:51'!
width

	^ self widthBlock
		ifNotNil: [ self widthBlock value: self ]
		ifNil: [ self privateWidth ]! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 18:45'!
widthBlock

	^ self valueOfProperty: #brickWidthBlock ifAbsentPut: [ nil ]! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 18:45'!
widthBlock: aBlock
	"you can use a block to 'fake' a width or replace it's calculation logic without extending a brick"
	self setProperty: #brickWidthBlock toValue: aBlock! !

GLMBrick subclass: #GLMInteractableBrick
	instanceVariableNames: 'normalImage pressedImage selectedImage checkedImage announcer checkedColor normalColor pressedColor selectedColor isSelected isPressed isChecked isEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMInteractableBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:08' prior: 0!
A GLMInteractableBrick is a subclass of GLMBrick to allow user interactions such as: mouseLeave, mouseEnter, mouseDown, mouseUp and for each state can change background color or background image, that resizes accordinately to Brick's size

Instance Variables
	announcer:		<Object>
	checkedColor:		<Object>
	checkedImage:		<Object>
	isChecked:		<Object>
	isEnabled:		<Object>
	isPressed:		<Object>
	isSelected:		<Object>
	normalColor:		<Object>
	normalImage:		<Object>
	pressedColor:		<Object>
	pressedImage:		<Object>
	selectedColor:		<Object>
	selectedImage:		<Object>

announcer
	- xxxxx

checkedColor
	- xxxxx

checkedImage
	- xxxxx

isChecked
	- xxxxx

isEnabled
	- xxxxx

isPressed
	- xxxxx

isSelected
	- xxxxx

normalColor
	- xxxxx

normalImage
	- xxxxx

pressedColor
	- xxxxx

pressedImage
	- xxxxx

selectedColor
	- xxxxx

selectedImage
	- xxxxx
!

GLMInteractableBrick subclass: #GLMActionButtonBrick
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMActionButtonBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:08' prior: 0!
A GLMActionButtonBrick is a button for Glamour actions, used in Tabbed presentations

Instance Variables
	action:		<Object>

action
	- xxxxx
!

!GLMActionButtonBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 16:19'!
action: anAction

	action := anAction.
	
	self normalImage: action icon.
	self pressedColor: Color veryVeryLightGray! !

!GLMActionButtonBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/16/2014 15:56'!
addUpAction: anActionOrBlock

	anActionOrBlock isBlock
		ifTrue: [ action := anActionOrBlock ]
		ifFalse: [ self action: anActionOrBlock ]! !

!GLMActionButtonBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/16/2014 15:52'!
click: evt

	action isBlock
		ifTrue: [ action value ]
		ifFalse: [ action performOn: self data ].
	
	^ true! !

!GLMActionButtonBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 15:53'!
icon: anImage

	self normalImage: anImage.! !

!GLMActionButtonBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/16/2014 16:19'!
initialize
	super initialize.
	
	self enable.! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:14'!
normalColorOf: aTrick
	^ self pressedColor: false selectedColor: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:14'!
normalOf: aTrick
	^ self pressed: false selected: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:14'!
pressed: isPressed of: aTrick
	^ self pressed: isPressed selected: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
pressed: isPressed selected: isSelected checked: isChecked of: aTrick
	"answers sender with image, corresponding specified state"
	
	"pressed has the highest priority"
	(isPressed & aTrick pressedImage notNil)
		ifTrue: [ ^ aTrick pressedImage ].
	
	(((isPressed & aTrick pressedImage isNil) | isSelected) & aTrick selectedImage notNil)
		ifTrue: [ ^ aTrick selectedImage ].
		
	(isChecked & aTrick checkedImage notNil)
		ifTrue: [ ^ aTrick checkedImage ].
	
	^ aTrick normalImage.! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
pressed: isPressed selected: isSelected of: aTrick
	^ self pressed: isPressed selected: isSelected checked: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
pressedColor: isPressed of: aTrick
	^ self pressedColor: isPressed selectedColor: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
pressedColor: isPressed selectedColor: isSelected checkedColor: isChecked of:aTrick
	"answers sender with image, corresponding specified state"
	
	"pressed has the highest priority"
	(isPressed & aTrick pressedColor notNil)
		ifTrue: [ ^ aTrick pressedColor ].
	
	(((isPressed & aTrick pressedColor isNil) | isSelected) & aTrick selectedColor notNil)
		ifTrue: [ ^ aTrick selectedColor ].
		
	(isChecked & aTrick checkedColor notNil)
		ifTrue: [ ^ aTrick checkedColor ].
	
	^ aTrick normalColor.! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
pressedColor: isPressed selectedColor: isSelected of: aTrick
	^ self pressedColor: isPressed selectedColor: isSelected checkedColor: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
selected: isSelected of: aTrick
	^ self pressed: false selected: isSelected of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
selectedColor: isSelected of: aTrick
	^ self pressedColor: false selectedColor: isSelected of: aTrick! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:48'!
check
	self isChecked ifFalse: [
		isChecked := true.
		self changed.
	]! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
checkedColor
	^ checkedColor! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
checkedColor: anObject
	checkedColor := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
checkedImage
	^ checkedImage! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
checkedImage: anObject
	checkedImage := anObject! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:47'!
click: evt
	^ false! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
currentColor
	^ self state pressedColor: (self isPressed) selectedColor: (self isSelected) checkedColor: (self isChecked) of: self! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
currentImage
	^ self state pressed: (self isPressed) selected: (self isSelected) checked: (self isChecked) of: self! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:48'!
depress
	self isPressed ifTrue: [
		isPressed := false.
		self changed.
		^ true
	].

	^ false! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/16/2014 23:33'!
deselect
	self isSelected ifTrue: [
		isSelected := false.
		self changed.
	]! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
disable
	isEnabled := false.! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
enable
	
	isEnabled := true.! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:10'!
handlesMouseDown: evt
	
	^ self isEnabled
		ifTrue: [ true ]
		ifFalse: [ super handlesMouseDown: evt ]
	! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:00'!
handlesMouseOver: evt
	^ self isEnabled
		ifTrue: [ true ]
		ifFalse: [ super handlesMouseDown: evt ]! !

!GLMInteractableBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/17/2014 10:20'!
initialize
	super initialize.
	
	isChecked := false.
	isPressed := false.
	isSelected := false.
	
	self renderer: GLMInteractableBrickRenderer.
	
	self disable.! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
isChecked
	^ isChecked.! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
isEnabled
	^ isEnabled! !

!GLMInteractableBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 10/11/2014 14:06'!
isFocused

	^ false! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
isPressed
	^ isPressed.! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
isSelected
	^ isSelected.! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:06'!
mouseDown: evt
	super mouseDown: evt.
	^ self press.! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:22'!
mouseEnter: evt
	super mouseEnter: evt.
	^ self select! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:22'!
mouseLeave: evt
	super mouseLeave: evt.
	^ self deselect! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/23/2014 20:00'!
mouseUp: evt
	super mouseUp: evt.
	(self bounds containsPoint: evt position) & (self isPressed) ifTrue: [
		self depress.
		^ self click: evt
	] ifFalse: [
		self deselect.
		^ self depress.
	]! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
normalColor
	^ normalColor! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
normalColor: anObject
	normalColor := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
normalImage
	^ normalImage! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
normalImage: anObject
	normalImage := anObject! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:48'!
press
	self isPressed ifFalse: [
		isPressed := true.
		self changed.
	].

	^ false! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
pressedColor
	^ pressedColor! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
pressedColor: anObject
	pressedColor := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
pressedImage
	^ pressedImage! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:45'!
pressedImage: anObject
	pressedImage := anObject! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/16/2014 23:33'!
select
	self isSelected ifFalse: [ 
		isSelected := true.
		self changed.
	]! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
selectedColor
	^ selectedColor! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:45'!
selectedColor: anObject
	selectedColor := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:45'!
selectedImage
	^ selectedImage! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:45'!
selectedImage: anObject
	selectedImage := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
state

	^ self class! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:48'!
uncheck
	self isChecked ifTrue: [
		isChecked := false.
		self changed.
	]! !

GLMInteractableBrick subclass: #GLMLabelBrick
	instanceVariableNames: 'isDotsAdded dotsBrick stringBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMLabelBrick commentStamp: 'AliakseiSyrel 10/18/2014 14:18' prior: 0!
A GLMLabelBrick is standard label Brick, that can shrink text if it's size becomes smaller then actual text size.

Text shrinking works out of box, you don't need to do anything

Instance Variables
	dotsBrick		<GLMStringBrick>
	isDotsAdded:		<boolean>
	stringBrick rick		<GLMStringBrick>

dotsBrick
	- represents a Brick that is added at the end of the text when Brick's size becomes smaller than actual text size

isDotsAdded
	- true if dotsBrick is currently added visible, false otherwise

stringBrick
	- represents actual label text Brick
!

!GLMLabelBrick methodsFor: 'default values' stamp: 'AliakseiSyrel 10/16/2014 14:33'!
defaultDotsText
	^ '...'! !

!GLMLabelBrick methodsFor: 'default values' stamp: 'AliakseiSyrel 10/16/2014 14:03'!
defaultInsetBeforeDots
	^ 1! !

!GLMLabelBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 10/17/2014 10:45'!
doLayout
	"contolls logic of text schrinking"
	|isFit|
	
	super doLayout.
	
	"checking if label text fits in me"
	isFit := self label isFitsInParent.
	
	(isFit & (self isDotsAdded not)) ifTrue: [ ^ self ].
	(isFit not & self isDotsAdded) ifTrue: [ ^ self ].
	
	(isFit & self isDotsAdded) ifTrue: [
		self removeBrick: self dotsBrick.
		isDotsAdded := false.
		super doLayout.
	] ifFalse: [ 
		self addBrickBack: self dotsBrick.
		isDotsAdded := true.
		super doLayout.
	]
	! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:00'!
dotsBrick

	^ dotsBrick! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 14:50'!
fontSize: anInteger

	self label fontSize: anInteger.
	self dotsBrick fontSize: anInteger.! !

!GLMLabelBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/22/2014 22:53'!
initialize
	super initialize.
	
	stringBrick := self newStringBrick.
	stringBrick layoutProperties horizontalPercent: 100.
	stringBrick layoutProperties marginRight: self defaultInsetBeforeDots.
	self addBrickBack: stringBrick.
	
	"creating dots morph, that will be displayed when text is being clipped"
	dotsBrick := GLMStringBrick new.
	dotsBrick layoutProperties horizontalPercent: 0.
	dotsBrick text: self defaultDotsText.
	dotsBrick layoutProperties minWidth: (dotsBrick textSize x).
	
	isDotsAdded := false.
	! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 14:05'!
isDotsAdded
	^ isDotsAdded! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:00'!
label
	^ stringBrick! !

!GLMLabelBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 10/17/2014 09:59'!
newStringBrick
	^ GLMStringBrick new! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 14:09'!
text
	^ self label text! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/5/2014 16:44'!
text: aString

	self label text: aString! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 13:29'!
textColor: aColor

	self label textColor: aColor.
	self dotsBrick textColor: aColor! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 13:21'!
textPosition: aSymbol

	self label textPosition: aSymbol.
	self dotsBrick textPosition: aSymbol.! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 14:42'!
weightValue: anInteger

	self label weightValue: anInteger.
	self dotsBrick weightValue: anInteger.! !

GLMInteractableBrick subclass: #GLMStringBrick
	instanceVariableNames: 'font familyName fontSize textSize text textColor textPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMStringBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:06' prior: 0!
A GLMStringBrick is low level String Brick. Text can't be drawn outside of Brick's bounds, which makes it very usefull for smart text shrinking.

Instance Variables
	familyName:		<Object>
	font:		<Object>
	fontSize:		<Object>
	text:		<Object>
	textColor:		<Object>
	textPosition:		<Object>
	textSize:		<Object>

familyName
	- xxxxx

font
	- xxxxx

fontSize
	- xxxxx

text
	- xxxxx

textColor
	- xxxxx

textPosition
	- xxxxx

textSize
	- xxxxx
!

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/18/2014 23:47'!
calculateTextPosition

	self textPosition = #leftCenter ifTrue: [ 
		^ (self brickBounds origin + self textPositionVerticalCenter) floor
	].

	self textPosition = #center ifTrue: [ 
		^ (self brickBounds origin + self textPositionVerticalCenter + self textPositionHorizontalCenter)floor
	].

	self textPosition = #leftTop ifTrue: [
		^ self brickBounds origin
	].

	self textPosition = #rightCenter ifTrue: [
		^ ((self brickBounds topRight + self textPositionVerticalCenter - (self textSize x@0)) max: self brickBounds origin) floor
	].

	^ self brickBounds origin! !

!GLMStringBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/16/2014 15:19'!
defaultColor
	^ Color black! !

!GLMStringBrick methodsFor: 'defaults' stamp: 'AliakseiSyrel 10/16/2014 15:14'!
defaultFamilyName
	^ self theme labelFont familyName! !

!GLMStringBrick methodsFor: 'defaults' stamp: 'AliakseiSyrel 10/17/2014 10:31'!
defaultSize
	^ self theme labelFont pointSize! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 15:14'!
familyName
	^ familyName! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:04'!
familyName: aString
	familyName := aString.
	self updateFont.! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:06'!
font

	^ font! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 16:34'!
font: aFont

	font := aFont.
	
	aFont ifNil: [ self updateFont ].
	
	familyName := font familyName.
	fontSize := font pointSize.! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:04'!
fontSize
	^ fontSize! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:05'!
fontSize: aNumber
	fontSize := aNumber.
	self updateFont.! !

!GLMStringBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/18/2014 16:34'!
initialize
	super initialize.
	
	fontSize := self defaultSize.
	familyName := self defaultFamilyName.
	textColor := self defaultColor.
	text := ''.
	
	textPosition := #leftCenter.
	
	self updateFont.
	! !

!GLMStringBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
isFitsInParent

	^ self brickOwner
		ifNil: [ self brickBounds containsRect: (self brickOuterBounds origin extent: self textSize) ]
		ifNotNil: [
			self brickOwner brickBounds extent >= self textSize ]
				! !

!GLMStringBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 11/19/2014 22:28'!
onDraw: aCanvas
	super onDraw: aCanvas.
	aCanvas
		drawString: self text
		at: self calculateTextPosition
		font: self font
		color: self textColor! !

!GLMStringBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/5/2014 16:50'!
privateSetText: aString

	text := aString.
	textSize := nil.! !

!GLMStringBrick methodsFor: 'public' stamp: 'AliakseiSyrel 10/4/2014 05:07'!
sizeOf: aString

	^ (self font widthOfString: aString) @ self font height! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:12'!
text

	^ text! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
text: aString
	|repaint|
	
	repaint := text size > 0.	
	self privateSetText: aString.

	repaint ifTrue: [ self brickOwner doLayout. self root changed ]! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 00:35'!
textColor
	^ textColor! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 00:36'!
textColor: aColor
	textColor := aColor.
	self updateFont.! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 01:13'!
textPosition

	^ textPosition! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 13:19'!
textPosition: aSymbol
	"supported:
	#leftCenter
	#center
	#leftTop
	"
	textPosition := aSymbol.! !

!GLMStringBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
textPositionHorizontalCenter

	^ ((((self brickBounds width - self textSize x) max: 0) /2)@0)! !

!GLMStringBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/25/2014 10:28'!
textPositionVerticalCenter

	^ (0@(self brickBounds height / 2)) - (0@(self fontSize/2)) - (0@3)! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:13'!
textSize

	^ textSize ifNil: [ textSize := self sizeOf: self text ]! !

!GLMStringBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/18/2014 16:33'!
updateFont
	font := LogicalFont familyName: self familyName pointSize: self fontSize.! !

GLMInteractableBrick subclass: #GLMTabLabelBrick
	instanceVariableNames: 'tabSelector normalLabel selectedLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMTabLabelBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:06' prior: 0!
A GLMTabLabelTurboBrick is  single resizable Tab Label used in LazyTabGroupMorph.

Instance Variables
	normalLabel:		<Object>
	selectedLabel:		<Object>
	tabSelector:		<Object>

normalLabel
	- xxxxx

selectedLabel
	- xxxxx

tabSelector
	- xxxxx
!

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
adoptPaneColor: paneColor
	"Use the theme for fillStyle and border."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self fillStyle: self fillStyleToUse.
	self borderStyle: self borderStyleToUse! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self isSelected
		ifTrue: [self theme tabLabelSelectedBorderStyleFor: self]
		ifFalse: [self theme tabLabelNormalBorderStyleFor: self]! !

!GLMTabLabelBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
deselect
	self layoutProperties minWidth: 0.
	self brickRoot changed.
	self brickRoot doLayout.
	self brickRoot changed.! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
fillStyleToUse
	"Answer the basic fill style for the receiver."

	^self isSelected
		ifTrue: [self selectedFillStyle] 
		ifFalse: [self normalFillStyle]! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
font: aFont
	"Set the label font"

	self normalLabel allMorphsDo: [:m |
		(m respondsTo: #font:) ifTrue: [m font: aFont]].
	self selectedLabel allMorphsDo: [:m |
		(m respondsTo: #font:) ifTrue: [m font: aFont]]! !

!GLMTabLabelBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/16/2014 23:26'!
initialize
	"Initialize the receiver."
	
	super initialize.
	self fillStyle: self fillStyleToUse.
	self borderStyle: self borderStyleToUse.
	
	self enable.! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
isSelected
	"Answer whether the tab is selected."

	^self tabSelector
		ifNil: [false]
		ifNotNil: [:selector | selector selectedTab == self]! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
label
	"Answer the label contents."

	^self isSelected
		ifTrue: [self selectedLabel userString ifNil: [self firstSubmorph]]
		ifFalse: [self normalLabel userString ifNil: [self firstSubmorph]]! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 16:42'!
label: aTrickMorph
	"Change the label contents"
	
	aTrickMorph layoutProperties horizontalPercent: 100.
	self layoutProperties maxWidthBlock: aTrickMorph layoutProperties maxWidthBlock.

	self
		normalLabel: aTrickMorph;
		selectedLabel: aTrickMorph;
		selected: self isSelected! !

!GLMTabLabelBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 11:01'!
label: aTrickMorph selected: selectedTrickMorph
	"Change the label contents"

	aTrickMorph layoutProperties horizontalPercent: 100.
	selectedTrickMorph layoutProperties horizontalPercent: 100.
	
	self layoutProperties maxWidthBlock: aTrickMorph layoutProperties maxWidthBlock.
	
	self
		normalLabel: aTrickMorph;
		selectedLabel: selectedTrickMorph;
		selected: self isSelected! !

!GLMTabLabelBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^self theme tabLabelNormalFillStyleFor: self! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
normalLabel

	^ normalLabel! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
normalLabel: anObject

	normalLabel := anObject! !

!GLMTabLabelBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
select
	self layoutProperties minWidth: (self label layoutProperties maxWidthBlock value: self label).
	self brickRoot doLayout.
	self brickRoot changed.! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
selected: aBoolean
	"Use the appropriate label."

	self removeAllBricks.
	self isSelected
		ifTrue: [self addBrickBack: self selectedLabel]
		ifFalse: [self addBrickBack: self normalLabel]! !

!GLMTabLabelBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
selectedFillStyle
	"Return the selected fillStyle of the receiver."
	
	^self theme tabLabelSelectedFillStyleFor: self! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
selectedLabel

	^ selectedLabel! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
selectedLabel: anObject

	selectedLabel := anObject! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
tabSelector

	^ tabSelector! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
tabSelector: anObject

	tabSelector := anObject! !

GLMBrick subclass: #GLMScrollPaneBrick
	instanceVariableNames: 'band lastScrollTimeStamp currentVelocity verticalScrollbar scrollPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMScrollPaneBrick commentStamp: 'AliakseiSyrel 10/18/2014 00:59' prior: 0!
A GLMScrollPaneBrick is a very simple scrollpane, that has no scrollbars.
For scrolling used acceleration algorithm, so as longer user scroll so faster it becomes.

Instance Variables
	band:		<Object>
	currentVelocity:		<Object>
	lastScrollTimeStamp:		<Object>

band
	- xxxxx

currentVelocity
	- xxxxx

lastScrollTimeStamp
	- xxxxx
!

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 01:11'!
defaultMaxVelocity
	^ self defaultScrollVelocity * 4! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 01:11'!
defaultScrollAcceleration
	^ 2! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 01:13'!
defaultScrollTimeReset
	^ 350! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 13:24'!
defaultScrollVelocity
	^ 15! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 00:25'!
example
	|foundation scrollPane|
	
	scrollPane := GLMScrollPaneBrick new.
	
	foundation := GLMFoundationBrick new.
	foundation brickRoot: scrollPane.
	
	1 to: 20 do: [ :index |
		scrollPane addBrickBack: (GLMBrick new
			color: Color random;
			extent: 200@50).
	].
	
	foundation extent: 200@200.
	
	foundation openInWindow! !

!GLMScrollPaneBrick methodsFor: 'adding' stamp: 'AliaskeiSyrel 11/8/2014 17:21'!
addBrick: aBrick before: anotherBrick
	band addBrick: aBrick before: anotherBrick! !

!GLMScrollPaneBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 23:03'!
addBrickBack: aBrick
	band addBrickBack: aBrick! !

!GLMScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 20:08'!
band

	^ band! !

!GLMScrollPaneBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 01:13'!
calculateVelocity: event
	
	event timeStamp - lastScrollTimeStamp > self class defaultScrollTimeReset
		ifTrue: [ currentVelocity := self class defaultScrollVelocity ]
		ifFalse: [ currentVelocity := (currentVelocity + self class defaultScrollAcceleration) min: self class defaultMaxVelocity ].
		
	lastScrollTimeStamp := event timeStamp.
	
	^ currentVelocity! !

!GLMScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 20:33'!
defaultScrollbarPosition

	^ #right! !

!GLMScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 20:32'!
defaultScrollbarWidth

	^ 5! !

!GLMScrollPaneBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 11/19/2014 21:03'!
doLayout
	super doLayout.
	
	band brickBounds: (band brickBounds translateBy: (0@(scrollPosition - band brickBounds top))).
	
	self verticalScrollbar update.! !

!GLMScrollPaneBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/18/2014 16:59'!
handlesMouseWheel: evt
	^ true! !

!GLMScrollPaneBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 11/19/2014 21:01'!
initialize
	super initialize.
	
	lastScrollTimeStamp := 0.
	currentVelocity := self class defaultScrollVelocity.
	scrollPosition := 0.
	
	band := GLMBandBrick new.
	
	self layoutPolicy: GLMBrickVerticalFillLinearLayout new.
	super addBrickBack: band.
	
	self verticalScrollbar: self newVerticalScrollbar! !

!GLMScrollPaneBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 11/19/2014 21:01'!
mouseWheel: event
	|velocity|
	super mouseWheel: event.
	
	velocity := self calculateVelocity: event.
	
	event direction = #up ifTrue: [
			"preventing from scrolling if already at the top"
			band brickBounds origin y >= 0 ifTrue: [ ^ self ].
			"actuall scrolling"
			band brickBounds: (band brickBounds translateBy: (0@ currentVelocity)).
			"returning scrollpane back if went away"
			band brickBounds origin y > 0 ifTrue: [ band brickBounds: (band brickBounds translateBy: (0@ band brickBounds origin y) negated) ] ].
		
	event direction = #down ifTrue: [
			band brickBounds corner y <= self height ifTrue: [ ^ self ].
			band brickBounds: (band brickBounds translateBy: (0@ currentVelocity) negated).
			band brickBounds corner y < self height ifTrue: [ band brickBounds: (band brickBounds translateBy: (0@ (self height - band brickBounds corner y))) ] ].
	
	scrollPosition := band brickBounds top.
	
	self verticalScrollbar update.
	self changed.! !

!GLMScrollPaneBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 11/19/2014 20:05'!
newVerticalScrollbar
	^ GLMScrollbarBrick new! !

!GLMScrollPaneBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/18/2014 01:16'!
removeAllBricks

	band subbricks do: [ :each |
		each isBrick ifTrue: [
			each brickRoot: nil.
			each brickOwner: nil ] ].
	
	band subbricks removeAll.
	band removeAllMorphs! !

!GLMScrollPaneBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 23:04'!
removeBrick: aBrick
	band removeBrick: aBrick! !

!GLMScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 11/21/2014 00:38'!
scrollTo: aBrick
	|delta|
	"if already visible no need to scroll"

	"need to normalize bounds to take only y coordinate into account"
	(((self globalBounds withWidth: 0) translateBy: (self globalBounds origin negated x@0))
		containsRect: ((aBrick globalBounds withWidth: 0) translateBy: (aBrick globalBounds origin negated x@0))) ifTrue: [ ^ self ].
	
	delta := ((self globalBounds top - band globalBounds top) - (aBrick globalBounds top - band globalBounds top)).
	delta < 0 ifTrue: [ delta := delta + self height - aBrick height ].
		
	band brickBounds: (band brickBounds translateBy: (0@ delta)).
	
	scrollPosition := band brickBounds top.
	
	self verticalScrollbar update.
	self changed.
	
	! !

!GLMScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 20:19'!
verticalScrollbar

	^ verticalScrollbar! !

!GLMScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 20:33'!
verticalScrollbar: aBrick

	verticalScrollbar := aBrick.
	verticalScrollbar width: self defaultScrollbarWidth.
	verticalScrollbar layoutProperties floating: self defaultScrollbarPosition.
	verticalScrollbar scrollPane: self.
	super addBrickBack: verticalScrollbar! !

GLMBrick subclass: #GLMScrollbarBrick
	instanceVariableNames: 'scrollPane bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMScrollbarBrick commentStamp: 'AliakseiSyrel 11/19/2014 20:32' prior: 0!
A GLMScrollbarBrick is vertical scollbar for a scrollpane. User can't interact with it

Instance Variables
	bar:		<Object>
	scrollPane:		<Object>

bar
	- xxxxx

scrollPane
	- xxxxx
!

!GLMScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/19/2014 20:11'!
bar

	^ bar! !

!GLMScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/19/2014 20:28'!
bar: aBrick

	bar := aBrick.
	bar color: Color veryLightGray.
	self addBrickBack: aBrick! !

!GLMScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/19/2014 20:27'!
initialize
	super initialize.
	
	self layoutPolicy: GLMBrickNoLayout new.
	self bar: self newBar! !

!GLMScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/19/2014 20:16'!
newBar

	^ GLMBrick new! !

!GLMScrollbarBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 20:08'!
scrollPane
	^ scrollPane! !

!GLMScrollbarBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 20:18'!
scrollPane: anObject
	scrollPane := anObject.
	self update.! !

!GLMScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/19/2014 20:59'!
update
	|height top width|
	
	self scrollPane band height = 0 ifTrue: [
		bar brickBounds: ((0@0) extent: 0@0).
		^ self changed.
	].
	
	height := (((self scrollPane height) / (self scrollPane band height)) * self height) ceiling.
	top := (((self height) / (self scrollPane band height)) * (self scrollPane band brickBounds top abs)) floor.
	
	width := (height >= self height)
		ifTrue: [ 0 ]
		ifFalse: [ self width ].
	
	bar brickBounds: ((0@top) extent: width@height).
	
	self changed! !

Morph subclass: #GLMFoundationBrick
	instanceVariableNames: 'brickRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets'!

!GLMFoundationBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:32' prior: 0!
A GLMFoundationBrick is connection layer between brick widgets and morphic.

See GLMBrick class comment for more info.

Instance Variables
	brickRoot:		<Object>

brickRoot
	- xxxxx
!

!GLMFoundationBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 09:48'!
addAllBricks: aCollection

	aCollection do: [ :each | self addBrickBack: each ]! !

!GLMFoundationBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 10:17'!
addBrickBack: aBrick

	self brickRoot addBrickBack: aBrick.! !

!GLMFoundationBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:21'!
brickRoot

	^ brickRoot! !

!GLMFoundationBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:22'!
brickRoot: aBrick

	self brickRoot ifNotNil: [
		self brickRoot brickOwner: nil.
		self brickRoot brickRoot: nil.
		self removeMorph: self brickRoot.
		brickRoot := nil.
	].
	
	brickRoot := aBrick.
	brickRoot brickOwner: self.
	brickRoot brickRoot: self.
	self addMorphBack: brickRoot.
	
	! !

!GLMFoundationBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
doLayout

	self brickRoot doLayout.! !

!GLMFoundationBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 11/20/2014 12:23'!
extent: aPoint
	|left top right bottom|
	
	super extent: aPoint.
	
	left := self brickRoot layoutProperties marginLeft.
	top := self brickRoot layoutProperties marginTop.
	
	right := self extent x - self brickRoot layoutProperties marginRight.
	bottom := self extent y - self brickRoot layoutProperties marginBottom.
	
	self brickRoot brickBounds: (left@top corner: (right@bottom)).
	
	self brickRoot doLayout.! !

!GLMFoundationBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/17/2014 23:47'!
fullDrawOn: aCanvas
	"preventing from drawing outside of me"
	super fullDrawOn: (aCanvas copyClipRect: self fullBounds).! !

!GLMFoundationBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/3/2014 18:43'!
globalBounds

	^ self bounds! !

!GLMFoundationBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/17/2014 10:12'!
initialize
	super initialize.
	
	self beTransparent.
	
	self brickRoot: GLMBrick new.
	self brickRoot layoutPolicy: GLMBrickHorizontalFillProportionalLinearLayout new.! !

!GLMFoundationBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 10/11/2014 15:38'!
isFocused

	^ false! !

!GLMFoundationBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/24/2014 13:04'!
privateExtent: aPoint

	super extent: aPoint.! !

!GLMFoundationBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/5/2014 13:51'!
relativeBounds

	^ 0@0 extent: self extent! !

!GLMFoundationBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
removeAllBricks

	self brickRoot removeAllBricks! !

GLMFoundationBrick subclass: #GLMTabSelectorBrick
	instanceVariableNames: 'selectedIndex visibleTabRange font tabs controls wrapScrolling'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets'!

!GLMTabSelectorBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:33' prior: 0!
A GLMTabSelectorBrick is a simplified TabSelectorMorph with support of smart tab resizing.
New implementation doesn't have any scrollbars or scroll arrows.

Instance Variables
	controls:		<Object>
	font:		<Object>
	selectedIndex:		<Object>
	tabs:		<Object>
	visibleTabRange:		<Object>
	wrapScrolling:		<Object>

controls
	- xxxxx

font
	- xxxxx

selectedIndex
	- xxxxx

tabs
	- xxxxx

visibleTabRange
	- xxxxx

wrapScrolling
	- xxxxx
!

!GLMTabSelectorBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
addTab: aStringOrMorph
	"Add a new tab with the given text."
	
	self tabs add: (self newLabelMorph: aStringOrMorph).
	self updateTabs! !

!GLMTabSelectorBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
addTab: aStringOrMorph selected: selectedStringOrMorph
	"Add a new tab with the given text or morph and alternate for when selected."
	
	self tabs add: (self newLabelMorph: aStringOrMorph selected: selectedStringOrMorph).
	self updateTabs! !

!GLMTabSelectorBrick methodsFor: 'rounding' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
cornerStyle: aSymbol
	"Pass to tabs also."

	super cornerStyle: aSymbol.
	self tabs do: [:t | t cornerStyle: aSymbol]! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
font
	"Answer the label font"

	^font! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
font: aFont
	"Set the label font"

	font == aFont ifTrue: [^self].
	font := aFont.
	self updateFont! !

!GLMTabSelectorBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
handlesKeyboard: evt
	"Yes, we do it here."
	
	^true! !

!GLMTabSelectorBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/16/2014 10:40'!
initialize
	"Initialize the receiver."

	super initialize.
	selectedIndex := 0.
	self
		tabs: OrderedCollection new;
		roundedCorners: #(1 4);
		borderWidth: 0.! !

!GLMTabSelectorBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
keyStroke: event 
	"Process keys navigation and space to toggle."

	(self navigationKey: event) ifTrue: [^self].
	event keyCharacter = Character arrowLeft
		ifTrue: [self selectPreviousTab].
	event keyCharacter = Character arrowRight
		ifTrue: [self selectNextTab]! !

!GLMTabSelectorBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."
	super keyboardFocusChange: aBoolean.
	self focusChanged! !

!GLMTabSelectorBrick methodsFor: 'layout' stamp: 'AliakseiSyrel 10/16/2014 17:31'!
minHeight
	^ self theme buttonMinHeight! !

!GLMTabSelectorBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 10/17/2014 09:45'!
newLabelMorph: aStringOrMorph
	"Answer a new label morph with the given label text."

	^GLMTabLabelBrick new
		roundedCorners: #(1 4);
		cornerStyle: self cornerStyle;
		label: aStringOrMorph;
		font: self font;
		on: #mouseDown send: #tabClicked:with: to: self;
		tabSelector: self! !

!GLMTabSelectorBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 10/17/2014 09:45'!
newLabelMorph: aStringOrMorph selected: selectedStringOrMorph
	"Answer a new label morph with the given label text or morph and
	alternate when selected."

	^GLMTabLabelBrick new
		roundedCorners: #(1 4);
		cornerStyle: self cornerStyle;
		label: aStringOrMorph selected: selectedStringOrMorph;
		font: self font;
		on: #mouseDown send: #tabClicked:with: to: self;
		tabSelector: self! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:39'!
relabelTab: aTab with: aStringOrMorph
	"Relabel the tab update tab layout."

	aTab label: aStringOrMorph.
	aTab owner ifNotNil: [
		self updateTabs ]! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
removeTabIndex: anInteger
	"Remove the tab at the given index and
	adjust any selected (next or first if was last)."
	
	self tabs removeAt: anInteger.
	self selectedIndex: 0.
	self tabs ifNotEmpty: [
		self selectedIndex: self selectedIndex - 1 \\ self tabs size + 1]
		! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
selectNextTab
	"Select the next tab, or the first if none selected."
	
	self selectedIndex: self selectedIndex \\ self tabs size + 1! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
selectPreviousTab
	"Select the previous tab, or the last if none selected."
	
	self selectedIndex: (self selectedIndex < 2
		ifTrue: [self tabs size]
		ifFalse: [self selectedIndex - 1])! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
selectedIndex
	"Answer the value of selectedIndex"

	^ selectedIndex! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:41'!
selectedIndex: index
	"Set the value of selectedIndex"

	|oldIndex|
	selectedIndex == index ifTrue: [^self].
	oldIndex := selectedIndex.
	selectedIndex := (index min: self tabs size).
	self updateTabs.
	self changed: #selectedIndex with: oldIndex! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
selectedTab
	"Answer the selected tab."
	
	^self selectedIndex = 0
		ifFalse: [self tabs at: self selectedIndex ifAbsent: [nil]]! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
tabClicked: evt with: aMorph 
	"A tab has been clicked."
	
	self selectedIndex: (self tabs indexOf: aMorph)! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
tabs

	^ tabs! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
tabs: anObject

	tabs := anObject! !

!GLMTabSelectorBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
updateFont
	"Update the label font."

	self tabs do: [:t | t font: self font].
	self updateTabs! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
updateTabs
	"Update the submorphs based on visible tabs."

	|selectedTab|
	self removeAllBricks.
	self tabs ifEmpty: [^self].
	selectedTab := self selectedTab.
	self tabs do: [:t |
		t selected: (t == selectedTab).
		t layoutProperties horizontalPercent: 100 / self tabs size ].
	self
		addAllBricks: self tabs;
		adoptPaneColor.
	
	self doLayout.! !

!Morph methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 10/17/2014 15:28'!
isBrick

	^ false! !

Announcement subclass: #GLMBrickAnnouncement
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Announcements'!

!GLMBrickAnnouncement commentStamp: 'AliakseiSyrel 10/17/2014 10:11' prior: 0!
A GLMBrickAnnouncement is default announcement used for any purpose by bricks.

Instance Variables
	data:		<Object>

data
	- xxxxx
!

!GLMBrickAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 16:22'!
data
	^ data! !

!GLMBrickAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 16:22'!
data: anObject
	data := anObject! !

GLMBrickAnnouncement subclass: #GLMBrickDataChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Announcements'!

!GLMBrickDataChanged commentStamp: 'AliakseiSyrel 10/17/2014 10:11' prior: 0!
A GLMBrickDataChanged is fired when GLMBrick>>data is changed
!

Object subclass: #GLMBrickRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Renderer'!

!GLMBrickRenderer commentStamp: 'AliakseiSyrel 10/17/2014 10:33' prior: 0!
A GLMBrickRenderer is most simple separate renderer of Bricks. It support only borders
!

!GLMBrickRenderer class methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:35'!
render: aBrick on: aCanvas

	self renderBorderOf: aBrick on: aCanvas.! !

!GLMBrickRenderer class methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:35'!
renderBorderOf: aBrick on: aCanvas
	|rect|
	
	rect := (aBrick brickBounds origin - (aBrick layoutProperties paddingLeft @ aBrick layoutProperties paddingTop)) corner: (aBrick brickBounds corner + (aBrick layoutProperties paddingRight @ aBrick layoutProperties paddingBottom)).

	aCanvas frameRectangle: rect width: aBrick borderWidth color: aBrick borderColor! !

!GLMBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
render: aBrick on: aCanvas

	self class render: aBrick on: aCanvas! !

!GLMBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
renderBorderOf: aBrick on: aCanvas

	self class renderBorderOf: aBrick on: aCanvas.! !

GLMBrickRenderer subclass: #GLMInteractableBrickRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Renderer'!

!GLMInteractableBrickRenderer commentStamp: 'AliakseiSyrel 10/17/2014 10:34' prior: 0!
A GLMInteractableBrickRenderer is more advanced Brick renderer, that is used in all interactable Bricks to allow on-fly change of background color or image
!

!GLMInteractableBrickRenderer class methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
render: aBrick on: aCanvas
	
	self renderColorOf: aBrick on: aCanvas.
	self renderImageOf: aBrick on: aCanvas.
	self renderBorderOf: aBrick on: aCanvas.! !

!GLMInteractableBrickRenderer class methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
renderColorOf: aBrick on: aCanvas
	|color|
	
	color := aBrick currentColor.
	color ifNotNil: [ aCanvas fillRectangle: aBrick brickBounds color: color ].! !

!GLMInteractableBrickRenderer class methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
renderImageOf: aBrick on: aCanvas
	|image|
	
	image := aBrick currentImage.
	
	image ifNotNil: [
		aCanvas 
			translucentImage: (GLMBrick resizeImage: image scale: (aBrick extent / image extent))
			at: aBrick brickBounds origin.
	].! !

!GLMInteractableBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
render: aBrick on: aCanvas
	
	self renderColorOf: aBrick on: aCanvas.
	self renderImageOf: aBrick on: aCanvas.! !

!GLMInteractableBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
renderColorOf: aBrick on: aCanvas
	self class renderColorOf: aBrick on: aCanvas! !

!GLMInteractableBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
renderImageOf: aBrick on: aCanvas
	self class renderImageOf: aBrick on: aCanvas! !

GLMInteractableBrickRenderer subclass: #GLMRoundButtonBrickRenderer
	instanceVariableNames: 'isRoundedLeft isRoundedRight antialiasing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Renderer'!

!GLMRoundButtonBrickRenderer commentStamp: 'AliakseiSyrel 11/20/2014 11:44' prior: 0!
A GLMRoundButtonBrickRenderer allows to render a button with rounded corners. Uses TrachelCanvas to support antialiasing

Instance Variables
	antialiasing:		<Object>
	isRoundedLeft:		<Object>
	isRoundedRight:		<Object>

antialiasing
	- xxxxx

isRoundedLeft
	- xxxxx

isRoundedRight
	- xxxxx
!

!GLMRoundButtonBrickRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
antialiasing

	^ antialiasing! !

!GLMRoundButtonBrickRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
antialiasing: aBoolean

	antialiasing := aBoolean! !

!GLMRoundButtonBrickRenderer methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
drawCircle: radius position: aPoint on: aCanvas color: aColor antialiasing: isAntialiased
	
	isAntialiased
		ifTrue: [ self drawTrachelCircle: radius position: aPoint on: aCanvas color: aColor ]
		ifFalse: [ self drawMorphicCircle: radius position: aPoint on: aCanvas color: aColor ]
	! !

!GLMRoundButtonBrickRenderer methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
drawMorphicCircle: radius position: aPoint on: aCanvas color: aColor

	aCanvas fillOval: (Rectangle origin: aPoint extent: ((2*radius)@(2*radius))) color: aColor borderWidth: 0 borderColor: Color transparent.! !

!GLMRoundButtonBrickRenderer methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
drawTrachelCanvas: trachelCanvas at: aPoint on: aCanvas
	|surface|
	
	surface := AthensCairoSurface extent: (trachelCanvas extent) asIntegerPoint.
	
	surface drawDuring: [:cs |
		surface clear.
		trachelCanvas shapes do: [ :trachelShape |
			trachelShape drawOn: cs.
		].
	].

	aCanvas image: surface asForm at: aPoint sourceRect: (0 @ 0 extent: surface extent) rule: 34.! !

!GLMRoundButtonBrickRenderer methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
drawTrachelCircle: radius position: aPoint on: aCanvas color: aColor
			
	self drawTrachelCanvas: (
		TRCanvas new addShape: (
			TRArcShape new
				color: aColor;
				alphaAngle: 0  betaAngle: 360  innerRadius: 0 externalRadius: radius;
				translateBy: radius @ radius
		)
	) at: aPoint on: aCanvas.! !

!GLMRoundButtonBrickRenderer methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
initialize
	super initialize.
	
	self isRoundedLeft: false.
	self isRoundedRight: false.
	self antialiasing: true.! !

!GLMRoundButtonBrickRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
isRoundedLeft
	^ isRoundedLeft! !

!GLMRoundButtonBrickRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
isRoundedLeft: anObject
	isRoundedLeft := anObject! !

!GLMRoundButtonBrickRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
isRoundedRight
	^ isRoundedRight! !

!GLMRoundButtonBrickRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
isRoundedRight: anObject
	isRoundedRight := anObject! !

!GLMRoundButtonBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 11/20/2014 11:59'!
renderColorOf: aBrick on: aCanvas
	|rectangle radius diameter bounds|
	
	bounds := aBrick brickBounds.
		
	radius := (aBrick height / 2) roundDownTo: 1.0.
	diameter := radius * 2.
	rectangle := bounds withHeight: diameter.
	
	self isRoundedLeft ifTrue: [ 
		self drawCircle: radius position: bounds topLeft on: aCanvas color: aBrick currentColor antialiasing: self antialiasing.
		rectangle := (rectangle withWidth: rectangle width - radius) translateBy: radius@0.
	].

	self isRoundedRight ifTrue: [
		self drawCircle: radius position: bounds topRight - (diameter@0) on: aCanvas color: aBrick currentColor antialiasing: self antialiasing.
		rectangle := rectangle withWidth: rectangle width - radius.
	].
	
	aCanvas fillRectangle: rectangle basicFillStyle: (SolidFillStyle color: aBrick currentColor).! !
